(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('prop-types')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react', 'prop-types'], factory) :
	(factory((global.buttermilk = {}),global.React,global.PropTypes));
}(this, (function (exports,React,PropTypes) { 'use strict';

	React = React && React.hasOwnProperty('default') ? React['default'] : React;
	PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;

	function unwrapExports (x) {
		return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
	}

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	var key = '__global_unique_id__';

	var gud = function () {
	  return global[key] = (global[key] || 0) + 1;
	};

	/**
	 * Copyright (c) 2013-present, Facebook, Inc.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 *
	 * 
	 */

	function makeEmptyFunction(arg) {
	  return function () {
	    return arg;
	  };
	}

	/**
	 * This function accepts and discards inputs; it has no side effects. This is
	 * primarily useful idiomatically for overridable function endpoints which
	 * always need to be callable, since JS lacks a null-call idiom ala Cocoa.
	 */
	var emptyFunction = function emptyFunction() {};

	emptyFunction.thatReturns = makeEmptyFunction;
	emptyFunction.thatReturnsFalse = makeEmptyFunction(false);
	emptyFunction.thatReturnsTrue = makeEmptyFunction(true);
	emptyFunction.thatReturnsNull = makeEmptyFunction(null);
	emptyFunction.thatReturnsThis = function () {
	  return this;
	};
	emptyFunction.thatReturnsArgument = function (arg) {
	  return arg;
	};

	var emptyFunction_1 = emptyFunction;

	/**
	 * Similar to invariant but only logs a warning if the condition is not met.
	 * This can be used to log issues in development environments in critical
	 * paths. Removing the logging code for production environments will keep the
	 * same logic and follow the same code paths.
	 */

	var warning = emptyFunction_1;



	var warning_1 = warning;

	var implementation = createCommonjsModule(function (module, exports) {

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

	exports.__esModule = true;



	var _react2 = _interopRequireDefault(React);



	var _propTypes2 = _interopRequireDefault(PropTypes);



	var _gud2 = _interopRequireDefault(gud);



	var _warning2 = _interopRequireDefault(warning_1);

	function _interopRequireDefault(obj) {
	  return obj && obj.__esModule ? obj : { default: obj };
	}

	function _classCallCheck(instance, Constructor) {
	  if (!(instance instanceof Constructor)) {
	    throw new TypeError("Cannot call a class as a function");
	  }
	}

	function _possibleConstructorReturn(self, call) {
	  if (!self) {
	    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
	  }return call && ((typeof call === 'undefined' ? 'undefined' : _typeof(call)) === "object" || typeof call === "function") ? call : self;
	}

	function _inherits(subClass, superClass) {
	  if (typeof superClass !== "function" && superClass !== null) {
	    throw new TypeError("Super expression must either be null or a function, not " + (typeof superClass === 'undefined' ? 'undefined' : _typeof(superClass)));
	  }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
	}

	var MAX_SIGNED_31_BIT_INT = 1073741823;

	// Inlined Object.is polyfill.
	// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
	function objectIs(x, y) {
	  if (x === y) {
	    return x !== 0 || 1 / x === 1 / y;
	  } else {
	    return x !== x && y !== y;
	  }
	}

	function createEventEmitter(value) {
	  var handlers = [];
	  return {
	    on: function on(handler) {
	      handlers.push(handler);
	    },
	    off: function off(handler) {
	      handlers = handlers.filter(function (h) {
	        return h !== handler;
	      });
	    },
	    get: function get() {
	      return value;
	    },
	    set: function set(newValue, changedBits) {
	      value = newValue;
	      handlers.forEach(function (handler) {
	        return handler(value, changedBits);
	      });
	    }
	  };
	}

	function onlyChild(children) {
	  return Array.isArray(children) ? children[0] : children;
	}

	function createReactContext(defaultValue, calculateChangedBits) {
	  var _Provider$childContex, _Consumer$contextType;

	  var contextProp = '__create-react-context-' + (0, _gud2.default)() + '__';

	  var Provider = function (_Component) {
	    _inherits(Provider, _Component);

	    function Provider() {
	      var _temp, _this, _ret;

	      _classCallCheck(this, Provider);

	      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	        args[_key] = arguments[_key];
	      }

	      return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.emitter = createEventEmitter(_this.props.value), _temp), _possibleConstructorReturn(_this, _ret);
	    }

	    Provider.prototype.getChildContext = function getChildContext() {
	      var _ref;

	      return _ref = {}, _ref[contextProp] = this.emitter, _ref;
	    };

	    Provider.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
	      if (this.props.value !== nextProps.value) {
	        var oldValue = this.props.value;
	        var newValue = nextProps.value;
	        var changedBits = void 0;

	        if (objectIs(oldValue, newValue)) {
	          changedBits = 0; // No change
	        } else {
	          changedBits = typeof calculateChangedBits === 'function' ? calculateChangedBits(oldValue, newValue) : MAX_SIGNED_31_BIT_INT;

	          changedBits |= 0;

	          if (changedBits !== 0) {
	            this.emitter.set(nextProps.value, changedBits);
	          }
	        }
	      }
	    };

	    Provider.prototype.render = function render() {
	      return this.props.children;
	    };

	    return Provider;
	  }(React.Component);

	  Provider.childContextTypes = (_Provider$childContex = {}, _Provider$childContex[contextProp] = _propTypes2.default.object.isRequired, _Provider$childContex);

	  var Consumer = function (_Component2) {
	    _inherits(Consumer, _Component2);

	    function Consumer() {
	      var _temp2, _this2, _ret2;

	      _classCallCheck(this, Consumer);

	      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
	        args[_key2] = arguments[_key2];
	      }

	      return _ret2 = (_temp2 = (_this2 = _possibleConstructorReturn(this, _Component2.call.apply(_Component2, [this].concat(args))), _this2), _this2.state = {
	        value: _this2.getValue()
	      }, _this2.onUpdate = function (newValue, changedBits) {
	        var observedBits = _this2.observedBits | 0;
	        if ((observedBits & changedBits) !== 0) {
	          _this2.setState({ value: _this2.getValue() });
	        }
	      }, _temp2), _possibleConstructorReturn(_this2, _ret2);
	    }

	    Consumer.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
	      var observedBits = nextProps.observedBits;

	      this.observedBits = observedBits === undefined || observedBits === null ? MAX_SIGNED_31_BIT_INT // Subscribe to all changes by default
	      : observedBits;
	    };

	    Consumer.prototype.componentDidMount = function componentDidMount() {
	      if (this.context[contextProp]) {
	        this.context[contextProp].on(this.onUpdate);
	      }
	      var observedBits = this.props.observedBits;

	      this.observedBits = observedBits === undefined || observedBits === null ? MAX_SIGNED_31_BIT_INT // Subscribe to all changes by default
	      : observedBits;
	    };

	    Consumer.prototype.componentWillUnmount = function componentWillUnmount() {
	      if (this.context[contextProp]) {
	        this.context[contextProp].off(this.onUpdate);
	      }
	    };

	    Consumer.prototype.getValue = function getValue() {
	      if (this.context[contextProp]) {
	        return this.context[contextProp].get();
	      } else {
	        return defaultValue;
	      }
	    };

	    Consumer.prototype.render = function render() {
	      return onlyChild(this.props.children)(this.state.value);
	    };

	    return Consumer;
	  }(React.Component);

	  Consumer.contextTypes = (_Consumer$contextType = {}, _Consumer$contextType[contextProp] = _propTypes2.default.object, _Consumer$contextType);

	  return {
	    Provider: Provider,
	    Consumer: Consumer
	  };
	}

	exports.default = createReactContext;
	module.exports = exports['default'];
	});

	unwrapExports(implementation);

	var lib = createCommonjsModule(function (module, exports) {

	exports.__esModule = true;



	var _react2 = _interopRequireDefault(React);



	var _implementation2 = _interopRequireDefault(implementation);

	function _interopRequireDefault(obj) {
	  return obj && obj.__esModule ? obj : { default: obj };
	}

	exports.default = _react2.default.createContext || _implementation2.default;
	module.exports = exports['default'];
	});

	var createContext = unwrapExports(lib);

	function regexify(path) {
	    return new RegExp(path
	    // escape regex reserved characters
	    .replace(/([/.?+])/g, '\\$1')

	    // handle wildcards: *
	    .replace(/[.]{0}[*](?![*])/g, '.*?\/?')

	    // handle splats: **
	    .replace(/[/][.]{0}[*]{2}(?![*])/g, '.*?')

	    // handle query strings: ?foo=bar
	    .replace(/\\[?]/, '.*?\\?.*?')

	    // handle optional segments: (/bar)
	    .replace(/\(([^)]+)\)/g, '(?:$1)?')

	    // handle dynamic fragments: /:bar
	    .replace(/\/:[^/()#?]*/g, '/([^/]*)') + '$');
	}

	var liteUrl_min = createCommonjsModule(function (module, exports) {
	/**
	 * lite-url - Small, JS lib that uses regex for parsing a URL into it's component parts.
	 * @version v1.0.5
	 * @link https://github.com/sadams/lite-url
	 * @license BSD-3-Clause
	 */
	(function () {
	  function r(r, n, t) {
	    var e = r.split(n),
	        o = e.shift();return t(o, e.join(n));
	  }function n(n) {
	    var t = { hash: "", host: "", hostname: "", origin: "", pathname: "", protocol: "", search: "", password: "", username: "", port: "" };return r(n, "#", function (n, e) {
	      e && (t.hash = e ? "#" + e : ""), r(n, "?", function (n, e) {
	        e && (t.search = "?" + e), n && r(n, "//", function (n, e) {
	          t.protocol = n, r(e, "/", function (n, e) {
	            t.pathname = "/" + (e || ""), (t.protocol || n) && (t.origin = t.protocol + "//" + n), r(n, "@", function (n, e) {
	              if (e) {
	                var o = n.split(":");t.username = o[0], t.password = o[1];
	              } else e = n;t.host = e, r(e, ":", function (r, n) {
	                t.hostname = r, n && (t.port = n);
	              });
	            });
	          });
	        });
	      });
	    }), t.href = t.origin + t.pathname + t.search + t.hash, t;
	  }function t(r) {
	    var n = {},
	        t = r.search;if (t) {
	      t = t.replace(new RegExp("\\?"), "");var e = t.split("&");for (var o in e) {
	        if (e.hasOwnProperty(o) && e[o]) {
	          var i = e[o].split("=");n[i[0]] = i[1];
	        }
	      }
	    }return n;
	  }function e(r) {
	    var e = i[r];return "undefined" != typeof e ? e : (e = n(r), e.params = t(e), i[r] = e, e);
	  }var i = {};return e.changeQueryParser = function (r) {
	    t = r;
	  }, ("undefined" != 'object' && module.exports && (exports = module.exports = e), exports.liteURL = e), e;
	}).call(this);
	});
	var liteUrl_min_1 = liteUrl_min.liteURL;

	var PATH_EXTRACTION_R = /:[^/?#()]*/g;

	function extractParamsFromPath(path) {
	    return (path.match(PATH_EXTRACTION_R) || []

	    // remove the leading colon
	    ).map(function (param) {
	        return param.slice(1);
	    });
	}

	function getRouteParamsForURL(route, url) {
	    if (!route.params.length) return {};

	    var result = url.match(route.test) || [];

	    if (result.length) result.shift(); // discard the catchall result

	    return result.reduce(function (params, result, index) {
	        return params[route.params[index]] = result, params;
	    }, {});
	}

	function valid(validator, url) {
	    if (validator instanceof RegExp) {
	        return validator.test(url);
	    } else if (validator instanceof Function) {
	        return validator(url);
	    }
	}

	function findRoute(routes, url) {
	    var route = routes.find(function (route) {
	        return valid(route.test, url);
	    });

	    if (route) {
	        if (route.redirect) return findRoute(routes, route.redirect);else return { route: route, url: url };
	    }

	    throw new Error('could not find a route for url ' + url);
	}

	function parseUrl(url) {
	    var parsed = new liteUrl_min(url);

	    parsed.query = parsed.search.slice(1).split('&').reduce(function (params, pair) {
	        if (pair) {
	            var idx = pair.indexOf('=');

	            params[pair.slice(0, idx)] = pair.slice(idx + 1);
	        }

	        return params;
	    }, {});

	    return parsed;
	}

	/**
	 * A client-side method for programmatically updating the routing state.
	 *
	 * Accepts a new url (absolute or relative) and an optional second boolean
	 * parameter controlling if a new browser history entry should be created.
	 *
	 * If you want to change the routing state on server, just pass a new url to
	 * the <Router> component.
	 */
	function route(url) {
	    var addNewHistoryEntry = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

	    history[addNewHistoryEntry ? 'pushState' : 'replaceState']({}, '', url);

	    // this is what triggers the routing to update
	    window.dispatchEvent(new Event('popstate'));
	}

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var CONTEXT = createContext('buttermilk');
	var BROWSER = typeof window !== 'undefined';
	var NOOP = function NOOP() {};

	/**
	 * The gist of Buttermilk's router is that it acts like a controlled component when used
	 * server-side (driven by `props.url`) and an uncontrolled one client-side (driven by the
	 * value of `window.location.href` and intercepted navigation events.)
	 *
	 * In the browser, use either a <Link> component or the route() method to change routes.
	 * The router will also automatically pick up popstate events caused by user-driven browser
	 * navigation (forward, back buttons, etc.)
	 */
	var Router = function (_React$Component) {
	    _inherits(Router, _React$Component);

	    function Router(props, context) {
	        _classCallCheck(this, Router);

	        var _this = _possibleConstructorReturn(this, (Router.__proto__ || Object.getPrototypeOf(Router)).call(this, props, context));

	        _initialiseProps.call(_this);

	        if (!BROWSER && !props.url) {
	            throw new Error('props.url is required for non-browser environments');
	        }

	        var routes = _this.processRoutes(props.routes);
	        var url = props.url || Router.getURL();

	        _this.state = _this.getStateUpdateForUrl(url, routes);

	        props.routerDidInitialize(_this.getContextValue(url, _this.state.activeRoute));
	        return _this;
	    }

	    /**
	     * In a browser setting, we only want to rely on browser navigation events
	     * to determine routing updates.
	     */


	    _createClass(Router, [{
	        key: 'shouldRecompute',
	        value: function shouldRecompute(nextProps) {
	            return nextProps.routes !== this.props.routes || nextProps.url !== this.state.url && !BROWSER;
	        }
	    }, {
	        key: 'componentWillReceiveProps',
	        value: function componentWillReceiveProps(nextProps) {
	            if (this.shouldRecompute(nextProps)) {
	                this.recomputeRoutingState(BROWSER ? this.state.url : nextProps.url, nextProps.routes);
	            }
	        }
	    }, {
	        key: 'componentDidMount',
	        value: function componentDidMount() {
	            window.addEventListener('popstate', this.handleLocationChange);
	            window.addEventListener('hashchange', this.handleLocationChange);
	        }
	    }, {
	        key: 'componentWillUpdate',
	        value: function componentWillUpdate() {
	            this.recomputeRoutingState;
	        }
	    }, {
	        key: 'componentWillUnmount',
	        value: function componentWillUnmount() {
	            window.removeEventListener('popstate', this.handleLocationChange);
	            window.removeEventListener('hashchange', this.handleLocationChange);
	        }
	    }, {
	        key: 'render',
	        value: function render() {
	            var contextValue = this.getContextValue(this.state.url, this.state.activeRoute);

	            return React.createElement(
	                CONTEXT.Provider,
	                { value: contextValue },
	                React.createElement(
	                    this.props.outerComponent,
	                    contextValue,
	                    this.renderChildren(this.state.children, contextValue)
	                )
	            );
	        }
	    }, {
	        key: 'renderChildren',
	        value: function renderChildren(renderable, routingProps) {
	            if (renderable === null) {
	                return React.createElement(this.props.loadingComponent, routingProps);
	            } else if (!React.isValidElement(renderable)) {
	                return React.createElement(renderable, routingProps);
	            } else {
	                return renderable;
	            }
	        }
	    }, {
	        key: 'processChildren',
	        value: function processChildren(unknown) {
	            if (unknown instanceof Promise) {
	                var instance = this;
	                instance.promise = unknown;
	                unknown.then(function handlePromiseResolution(result) {
	                    /**
	                     * Is this promise still valid? If not, ignore the
	                     * resolution.
	                     */
	                    if (instance.promise === this) {
	                        instance.setState({ children: result });
	                        this.promise = null;
	                    }
	                }.bind(unknown), NOOP);

	                return null;
	            } else {
	                return unknown;
	            }
	        }

	        /**
	         * Returns a react-router-esque object with parsed location and params.
	         */

	    }, {
	        key: 'processRoutes',
	        value: function processRoutes(routes) {

	            return routes.map(function (route$$1) {
	                return Object.assign({}, route$$1, {
	                    params: extractParamsFromPath(route$$1.path),
	                    test: regexify(route$$1.path)
	                });
	            });
	        }
	    }, {
	        key: 'getStateUpdateForUrl',
	        value: function getStateUpdateForUrl(url, routes) {
	            var result = findRoute(routes, url);

	            return {
	                activeRoute: result.route,
	                children: this.processChildren(result.route.render(this.getContextValue(result.url, result.route))),
	                routes: routes,
	                url: result.url
	            };
	        }
	    }]);

	    return Router;
	}(React.Component);

	/**
	 * Compose it like this:
	 *
	 * <RoutingState>
	 *   {({ location, params, route }) => {
	 *      return <div>{location.pathname}</div>
	 *   }}
	 * </RoutingState>
	 */
	Router.propTypes = {
	    /**
	     * Provide a spinner or something to look at while the promise
	     * is in flight if using async routes.
	     */
	    loadingComponent: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),

	    /**
	     * An optional app runtime component. Think of it like the "shell" of your
	     * app, so perhaps the outer container, nav bar, etc. You'll probably want to
	     * put any "Provider" type components here that are intended to wrap your
	     * whole application.
	     */
	    outerComponent: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),

	    routes: PropTypes.arrayOf(PropTypes.shape({
	        /**
	         * A RegExp, string, or function accepting the URL as
	         * an argument and returning a boolean if valid.
	         */
	        path: PropTypes.oneOfType([PropTypes.instanceOf(RegExp), PropTypes.string, PropTypes.func]).isRequired,

	        /**
	         * A string URL path to a different route. If this is given,
	         * then "render" is not required.
	         */
	        redirect: PropTypes.string,

	        /**
	         * A function that returns one of the following:
	         *
	         * 1. JSX.
	         * 2. A React component class.
	         * 3. A promise resolving to JSX or a React component class.
	         */
	        render: PropTypes.func
	    })).isRequired,

	    /**
	     * A hook for reacting to an impending route transition. Accepts a promise
	     * and will pause the route transition until the promise is resolved. Return
	     * false or reject a given promise to abort the routing update.
	     *
	     * Provides currentRouting and nextRouting as arguments.
	     */
	    routeWillChange: PropTypes.func,

	    /**
	     * A hook for reacting to a completed route transition. It might be used
	     * for synchronizing some global state if desired.
	     *
	     * Provides currentRouting and previousRouting as arguments.
	     */
	    routeDidChange: PropTypes.func,

	    /**
	     * A hook for synchronizing initial routing state.
	     *
	     * Providers initialRouting as an argument.
	     */
	    routerDidInitialize: PropTypes.func,

	    /**
	     * The initial URL to be used for processing, falls back to
	     * window.location.href for non-SSR. Required for environments without
	     * browser navigation eventing.
	     */
	    url: PropTypes.string
	};
	Router.defaultProps = {
	    loadingComponent: 'div',
	    outerComponent: 'div',
	    routeDidChange: NOOP,
	    routeWillChange: NOOP,
	    routerDidInitialize: NOOP,
	    url: ''
	};

	Router.getURL = function () {
	    return window.location.href;
	};

	var _initialiseProps = function _initialiseProps() {
	    var _this4 = this;

	    this.noFallbackWarningEmitted = false;
	    this.promise = null;

	    this.handleLocationChange = function () /* event */{
	        var currentValue = _this4.getContextValue(_this4.state.url, _this4.state.activeRoute);

	        var _findRoute = findRoute(_this4.state.routes, Router.getURL()),
	            nextRoute = _findRoute.route,
	            nextUrl = _findRoute.url;

	        var nextValue = _this4.getContextValue(nextUrl, nextRoute);
	        var result = _this4.props.routeWillChange(currentValue, nextValue);
	        var cb = function cb() {
	            return _this4.props.routeDidChange(nextValue, currentValue);
	        };
	        var finish = function finish() {
	            return _this4.recomputeRoutingState(nextUrl, _this4.state.routes, cb);
	        };

	        if (result === false) return;else if (result instanceof Promise) result.then(finish, NOOP);else finish();
	    };

	    this.recomputeRoutingState = function (url, routes, cb) {
	        _this4.setState(_this4.getStateUpdateForUrl(url, routes === _this4.state.routes ? routes : _this4.processRoutes(routes)), cb);
	    };

	    this.getContextValue = function (url, route$$1) {
	        return {
	            location: parseUrl(url),
	            params: getRouteParamsForURL(route$$1, url),
	            route: route$$1
	        };
	    };
	};

	var RoutingState = CONTEXT.Consumer;

	/**
	 * A polymorphic anchor link component. On click/tap/enter if the destination
	 * matches a value route, the routing context will be modified without
	 * reloading the page. Otherwise, it will act like a normal anchor link.
	 *
	 * If something other than an anchor tag is specified via props.as, a
	 * [role="link"] attribute will be added for basic assistive technology support.
	 *
	 * Adds [data-active] if the given href matches the active route.
	 */
	var Link = function (_React$PureComponent) {
	    _inherits(Link, _React$PureComponent);

	    function Link() {
	        var _ref;

	        var _temp, _this2, _ret;

	        _classCallCheck(this, Link);

	        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	            args[_key] = arguments[_key];
	        }

	        return _ret = (_temp = (_this2 = _possibleConstructorReturn(this, (_ref = Link.__proto__ || Object.getPrototypeOf(Link)).call.apply(_ref, [this].concat(args))), _this2), _this2.handleNavigationIntent = function (e) {
	            if (e.type !== 'keydown' || e.type === 'keydown' && (e.key === 'Enter' || e.key === 'Space')) {
	                e.preventDefault();
	                e.stopPropagation();

	                if (e.metaKey || e.target.getAttribute('target') === '_blank') {
	                    window.open(_this2.props.href);
	                } else {
	                    route(_this2.props.href);
	                }
	            }
	        }, _temp), _possibleConstructorReturn(_this2, _ret);
	    }

	    _createClass(Link, [{
	        key: 'render',
	        value: function render() {
	            var _this3 = this;

	            return React.createElement(
	                CONTEXT.Consumer,
	                null,
	                function (_ref2) {
	                    var route$$1 = _ref2.route;

	                    return React.createElement(_this3.props.as, Object.assign({}, _this3.props, {
	                        'data-active': valid(route$$1.test, _this3.props.href) ? '' : undefined,
	                        as: undefined,
	                        href: _this3.shouldRenderAnchorProps() ? _this3.props.href : undefined,
	                        role: _this3.shouldRenderRole() ? 'link' : undefined,
	                        onClick: _this3.handleNavigationIntent,
	                        onKeyDown: _this3.handleNavigationIntent,
	                        onTouchEnd: _this3.handleNavigationIntent,
	                        target: _this3.shouldRenderAnchorProps() ? _this3.props.target : undefined
	                    }));
	                }
	            );
	        }
	    }, {
	        key: 'shouldRenderAnchorProps',
	        value: function shouldRenderAnchorProps() {
	            return this.props.as === Link.defaultProps.as || typeof this.props.as !== 'string';
	        }
	    }, {
	        key: 'shouldRenderRole',
	        value: function shouldRenderRole() {
	            return this.props.as !== Link.defaultProps.as;
	        }
	    }]);

	    return Link;
	}(React.PureComponent);
	Link.propTypes = {
	    /**
	     * An HTML tag name or valid ReactComponent class to be rendered. Must
	     * be compatible with React.createElement.
	     *
	     * Defaults to an anchor "a" tag.
	     */
	    as: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),

	    /**
	     * A valid relative or absolute URL string.
	     */
	    href: PropTypes.string.isRequired,

	    /**
	     * Any valid value of the anchor tag "target" attribute.
	     *
	     * See: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a#attr-target
	     */
	    target: PropTypes.string
	};
	Link.defaultProps = {
	    as: 'a'
	};

	exports.route = route;
	exports.Router = Router;
	exports.RoutingState = RoutingState;
	exports.Link = Link;

	Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=umd.js.map
